/*[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]*/
/*UInspector.p*/
/*Copyright  1987-1990 by Apple Computer, Inc.  All rights reserved.*/

/*
This unit implements two things: a set of lists of all objects in each class. and
the inspector window (with its associated views.) The global routines below
together make up the public interface to the inspector. The classes used are
private to the unit and are declared in UInspector.inc1.p. Refer to that source
code for more information on the implementation of this unit.
*/
#ifndef  __UInspector__
#define __UInspector__  0
#endif
#if  ! __UInspector__
#define __UInspector__  1

		/*  Required for this unit's interface. Auto-Include them */
#ifndef  __UObject__
#include "UObject.h"
#endif

extern pascal void InitUInspector(void);
		/* Called during MacApp initialization.  Initializes this unit.*/

extern pascal void AddObjectToInspector(TObject *theObject);
		/* Called when a new object is created by New or cloning. Adds theObject to the list of
        objects for its class. */

extern pascal void RemoveObjectFromInspector(TObject *theObject);
	   /* Called when an object is freed. Removes theObject from the list of objects for its cl
		  ass. */

extern pascal void MakeInspector(void);
		/* Called during MacApp initialization to make the Inspector document. Must be called after
        creating gApplication.*/

extern pascal void MakeInspectorWindow(void);
		/* Called to make a new Inspector window.*/
#endif

