{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ULoMem.p}
{Copyright  1988-1990 by Apple Computer Inc.  All rights reserved}

{ This unit provides a friendly interface to low memory variables (see Inside Macintosh.) The
global "routines" are, in fact, inline functions which directly access the low memory
variables. }

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := FALSE}
{$ENDC}

{$IFC NOT UsingIncludes}
UNIT ULoMem;

	INTERFACE
		{$ENDC}

		{$IFC UNDEFINED __ULoMem__}
		{$SETC __ULoMem__ := FALSE}
		{$ENDC}

		{$IFC NOT __ULoMem__}
		{$SETC __ULoMem__ := TRUE}

		{$I+}
		{$SETC ULoMemlsIncludes := UsingIncludes}
		{$SETC UsingIncludes := TRUE}
		{$IFC UNDEFINED UsingSysEqu} {$I SysEqu.p} {$ENDC}
		{$IFC UNDEFINED UsingDevices} {$I Devices.p} {$ENDC}
		{$SETC UsingIncludes := ULoMemlsIncludes}

   {------------------------------------------------------------------------------------
   NOTE: + = ROM128K or newer
   ------------------------------------------------------------------------------------}

		CONST
			{ This are needed for the non script manager case...}
			kLMApFontID 		= $984; 				{ Integer - Resource ID of application font
														 }
			kLMSysFontFam		= $BA6; 				{+ System font family ID or zero }
			kLMSysFontSize		= $BA8; 				{+ System font size (or zero for 12 point) }
			kLMTESysJust		= TESysJust;			{+ System font size (or zero for 12 point) }
			{ To here }

			kLMHiliteMode		= HiliteMode;			{ Clr bit seven to make next QD Op use
														 selection color }
			kLMExTable			= $00;					{ Address of exception vector table }

			{ for ROMMapInsert }
			kLMmapTrue			= - 1;
			kLMmapFalse 		= 0;

		CONST
			{ The following constants are instructions used in the various inline functions. }
			kMoveLImmed 		= $2EBC;				{ MOVE.L of immediate data to (SP) }
			kMoveBAbsolute		= $1EB8;				{ MOVE.B of absolute Address data to (SP) }
			kMoveWAbsolute		= $3EB8;				{ MOVE.W of absolute Address data to (SP) }
			kMoveLAbsolute		= $2EB8;				{ MOVE.L of absolute Address data to (SP) }

		TYPE
			{ for GetUTableBase }
			UnitTable			= ARRAY [0..128] OF DCtlhandle;
			UnitTablePtr		= ^UnitTable;

			RgnHandlePtr		= ^RgnHandle;

		FUNCTION GetTheCrsr: CursPtr;					{ pointer to current cursor}
			INLINE kMoveLImmed, $0000, TheCrsr; 		{ MOVE.L #TheCrsr,(SP) }

		FUNCTION GetSaveVisRgnPtr: RgnHandlePtr;		{ Temporarily saved VisRegion during Update
														 cycle }
			INLINE $41F8, $09F2, $2E88; 				{ LEA $9f2, A0 MOVE.L A0,(SP) }

		FUNCTION GetLMMBarHeight: INTEGER;				{ Menu bar height--not supported on 64K
														 ROMs. If the system has the Script
														 Manager, then use the GetMBarHeight
														 function }
			INLINE kMoveWAbsolute, $BAA;				{ MOVE.W MBarHeight,(SP) ??? symbolic name
														 in MPW 3.1 }

		FUNCTION GetCurStackBase: Ptr;					{ Current stack base }
			INLINE kMoveLAbsolute, CurStackBase;		{ MOVE.L CurStackBase,(SP) }

		FUNCTION GetHwCfgFlags: INTEGER;				{+ Hardware Configuration flags }
			INLINE kMoveWAbsolute, $B22;				{ MOVE.W $B22,(SP) }

		FUNCTION GetWindowList: WindowPtr;				{ Z-ordered linked list of windows }
			INLINE kMoveLAbsolute, WindowList;			{ MOVE.L #WindowList,(SP) }

		FUNCTION GetFSFCBLen: INTEGER;					{ End of file system variables, >0=has HFS }
			INLINE kMoveWAbsolute, $3F6;				{ MOVE.W $3F6,(SP) }

		FUNCTION GetCurJTOffset: INTEGER;				{ Offset from A5 to start of jump table }
			INLINE kMoveWAbsolute, CurJTOffset; 		{ MOVE.W CurJTOffset,(SP) }

		FUNCTION GetUnitNtryCnt: INTEGER;				{ Number of entries in unit table }
			INLINE kMoveWAbsolute, UnitNtryCnt; 		{ MOVE.W UnitNtryCnt,(SP) }

		FUNCTION GetUTableBase: UnitTablePtr;			{ Start of unit table }
			INLINE kMoveLAbsolute, UTableBase;			{ MOVE.L UTableBase,(SP) }

		FUNCTION GetCrsrBusy: SignedByte;				{ Cursor locked out}
			INLINE kMoveBAbsolute, CrsrBusy;			{ MOVE.B CrsrBusy,(SP) }

		FUNCTION GetROMMapInsert: Ptr;					{+ $FF=Look first in ROM resources file,
														 $00=Don't look in ROM }
			INLINE kMoveLImmed, $0000, RomMapInsert;	{ MOVE.L #ROMMapInsert,(SP) }

		FUNCTION GetMenuList: Handle;					{ Current menuBar list structure }
			INLINE kMoveLAbsolute, $A1C;				{ MOVE.L $A1C,(SP) }

		FUNCTION GetGZMoveHnd: Handle;					{ moving handle for GrowZone }
			INLINE kMoveLAbsolute, GZMoveHnd;			{ MOVE.L GZMoveHnd,(SP) }

		FUNCTION GetGZRootHnd: Handle;					{ Block which must not be moved by GrowZone
														 function}
			INLINE kMoveLAbsolute, GZRootHnd;			{ MOVE.L GZRootHnd,(SP) }

		FUNCTION GetResLoad: BOOLEAN;
			INLINE kMoveBAbsolute, ResLoad; 			{ MOVE.B ResLoad,(A7) }
		{ Returns the ResLoad flag from low memory.  True indicates that resources
		are loaded on GetResource. }

		{$ENDC} 										{ __ULoMem__ }

		{$IFC NOT UsingIncludes}
END.
{$ENDC}
